SystemOrganization addCategory: #'Mabinogi-Web-Components'!
SystemOrganization addCategory: #'Mabinogi-Web'!
SystemOrganization addCategory: #'Mabinogi-Web-Application'!

!BlockClosure methodsFor: '*mabinogi-web-components' stamp: 'StuartHerring 6/21/2012 18:12'!
asTableSource
	^MbBlockTableSource on: self! !

WASystemConfiguration subclass: #MbObjectPoolFilterConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbObjectPoolFilterConfiguration methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 13:08'!
describeOn: config
	(config string: #poolId)
		group: #Pool.
	(config string: #selector)
		group: #Pool.! !

WAConfiguredRequestFilter subclass: #MbObjectPoolFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web'!

!MbObjectPoolFilter methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/23/2012 13:11'!
defaultConfiguration
	^WAUserConfiguration new
		addParent: MbObjectPoolFilterConfiguration instance;
		at: #poolId put: 'pool';
		at: #selector put: 'pool';
		yourself! !

WAComponent subclass: #MbTabbedComponent
	instanceVariableNames: 'children current navType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Application'!

!MbTabbedComponent class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/23/2012 16:27'!
withAll: aCollection
	^aCollection inject: self new into: [ :x :each | x add: each. x]	! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:38'!
add: aComponent
	current ifNil: [ current := aComponent].
	children add: aComponent.! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/23/2012 16:39'!
beList
	navType := 'nav-list'! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/23/2012 16:39'!
bePills
	navType := 'nav-pills'.! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/23/2012 16:39'!
beTabs
	navType := 'nav-tabs'.! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/10/2012 16:57'!
children
	^(OrderedCollection 
		withAll: children)
		add: current;
		yourself.! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/23/2012 16:39'!
initialize
	super initialize.
	children := OrderedCollection new.
	current := nil.
	self beTabs! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/29/2012 20:02'!
renderActionsOn: html
! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/29/2012 20:49'!
renderContentOn: html
	html row: [
		html heading level: 2; pullLeft; with: current title.
		self renderActionsOn: html].
	html row class: 'tabs-left'; with:  [
	html unorderedList span: 2;  class: 'nav nav-stacked'; class: navType; with: [
			children do: [ :each | self renderItem: each on: html ]].
	html div span: 10; with: current]! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 21:02'!
renderItem: aComponent on: html
	html listItem class: 'active' if: (current = aComponent); with: [
		html anchor callback: [ current := aComponent]; with: aComponent title]! !

!MbTabbedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/10/2012 15:57'!
states
	^Array with: current! !

WAComponent subclass: #MbTable
	instanceVariableNames: 'values source columns rowStyleBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

MbTable subclass: #MbPagingTable
	instanceVariableNames: 'page pageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:19'!
initialize
	super initialize.
	pageSize := 15.
	page :=1! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:19'!
pageSize: aNumber
	pageSize := aNumber! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:32'!
renderContentOn: html
	html div: [
		super renderContentOn: html.
		self renderNavigationOn: html]! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:48'!
renderNavigation: aRenderable condition:  conditionBlock callback:  callback on: html
	| id anchor enabled |
	enabled := conditionBlock value.
	html listItem 
		class: 'disabled' if: enabled not;
		with: [
			anchor := html anchor id: (id := html nextId).
			enabled ifTrue: [
				anchor 	
					callback: callback;
					onClick: ((html jQuery this parentsUntil: 'div') parent parent load html: [ :h | callback value. self renderContentOn: h.  ]);
					onClick: 'return false;'].
			anchor with: aRenderable]! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:49'!
renderNavigationOn: html
	| items |
	items := self items.
	items size < pageSize ifTrue: [^ self].	
	html div class: 'pagination'; with: [ html unorderedList: [
		self renderNavigation: [ html icon: 'fast-backward' ] condition: [ page > 1 ] callback: [ page := 1 ] on: html.
	self renderNavigation: [ html icon: 'backward' ] condition: [ page > 1 ] callback: [ page := page - 1 ] on: html.
	html listItem class: 'active'; with: [html anchor: (' {1} - {2} of {3} ' format: {(page - 1) * pageSize + 1. (page * pageSize) min: items size.  items size})].
	self renderNavigation: [ html icon: 'forward' ] condition: [ page *  pageSize < items size ] callback: [ page := page + 1 ] on: html.
	self renderNavigation: [ html icon: 'fast-forward'] condition: [ page * pageSize < items size ] callback: [ page := ((items size / pageSize) + 0.5) rounded] on: html]]! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:19'!
resetPage
	page := 1.! !

!MbPagingTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:30'!
thisPageItems
	| items |
	items := self items.
	^items copyFrom: ((page - 1) * pageSize) + 1to: ((page  * pageSize) min: items size).! !

!MbTable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:22'!
new
	self shouldNotImplement! !

!MbTable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:07'!
on: anMbTableSource
	^self basicNew
		initializeWith: anMbTableSource asTableSource! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 19:22'!
addColumn: aColumnDefinition
	columns add: aColumnDefinition! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:20'!
addColumn: aHeading as: aBlock
	self addColumn: (MbSimpleValueTableColumn new heading: aHeading; valueBlock: aBlock; yourself)! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:25'!
addColumn: aHeading renderedWith: aBlock
	self addColumn: (MbTableColumn new heading: aHeading; renderBlock: aBlock; yourself)! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:20'!
addColumns: aCollectionOrObject
	aCollectionOrObject isCollection 
		ifTrue: [ aCollectionOrObject do:  [ :i | self addColumn: i ]]
		ifFalse: [ aCollectionOrObject mbDefinitions do: [ :def | self addColumn: (MbSimpleValueTableColumn forDefinition: def) ] ]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/23/2012 17:03'!
initializeWith: anMbTableSource
	self initialize.
	source := anMbTableSource.
	columns := OrderedCollection new.
	rowStyleBlock := [ :item :row | ]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:15'!
items
	^source items! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:30'!
renderContentOn: html
	html table class: 'table-condensed table-striped table-bordered'; with: [
		self renderHeadingsOn: html.
		html tableBody: [
			self thisPageItems do: [ :item | self renderItem: item on: html]]]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:02'!
renderHeadingsOn: html
	html tableHead: [ html tableRow: [ 
		columns do: [ :c | c renderHeadingOn: html ]]]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/23/2012 17:03'!
renderItem: anObject on: html
	| row |
	row := html tableRow.
	self updateRow: row forItem: anObject.
	row with: [
		columns do: [ :c | c renderItem: anObject on: html ]]! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/23/2012 17:03'!
rowStyle: aTwoArgumentBlock
	rowStyleBlock := aTwoArgumentBlock! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/24/2012 14:30'!
thisPageItems
	^self items! !

!MbTable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/23/2012 17:04'!
updateRow: aRow forItem: anItem
	rowStyleBlock value: aRow value: anItem! !

WAComponent subclass: #MbValidatedComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

MbValidatedComponent subclass: #MbField
	instanceVariableNames: 'definition model value messages onChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

MbField subclass: #MbDateField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbDateField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/6/2012 22:09'!
supportedRenderHints
	^#(datePicker)! !

!MbDateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:39'!
renderFieldWithId: anId on: html
	html textInput
		id: anId;
		script: (html jQuery new datepicker 
	         onSelect: (html jQuery ajax serializeThis);
		   dateFormat: 'd MM yy');
		on: #value of: self.
! !

!MbDateField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:05'!
save
	definition setModelValue: value asDate! !

MbField subclass: #MbDropdownField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbDropdownField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 19:01'!
supportedRenderHints
	^#(dropDown)! !

!MbDropdownField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:34'!
renderFieldWithId: anId on: html
	| select |
	select := html select
		id: anId;
		list: definition values;
		on: #value of: self.		
	definition required ifFalse: [ select beOptional  ]! !

!MbDropdownField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:32'!
reset
	value := model! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:54'!
definition: aDefinition model: anObject
	^(self findClassFor: aDefinition) 
		ifNotNil: [ :c | c definition: aDefinition model: anObject	]
		ifNil: [ self basicNew
			initializeWithDefinition: aDefinition model: anObject;
			yourself]! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 18:30'!
findClassFor: aDefinition
	^aDefinition embedded ifTrue: [MbFieldGroup ]
		ifFalse: [self allSubclasses detect: [ :fieldClass | fieldClass supports: aDefinition ] ifNone: [nil]]! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:57'!
supportedRenderHints
	^#()! !

!MbField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:57'!
supports: aDefinition
	^self supportedRenderHints includes: aDefinition renderHint! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 18:25'!
clearMessages
	messages := #()! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/15/2012 19:31'!
initializeWithDefinition: aDefinition model: anObject
	self initialize.
	definition := aDefinition.
	model := anObject.
	messages := #().
	self reset.
	onChange := [ :v | ]! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:06'!
messages
	^messages! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/4/2012 21:23'!
model: anObject
	model := anObject! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 20:24'!
onChange: aBlock
	onChange := aBlock! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/3/2012 20:00'!
renderContentOn: html
	| id |
	html controlGroup
		attributeAt: 'data-selector' put: definition selector;
		class: #error if: self valid not;
		with: [
			self renderLabelFor: (id := html nextId) on: html.
			html controls: [
			self renderFieldWithId: id on: html.
			self valid ifFalse: [
				 self messages do: [ :m | html span class: 'help-inline'; with: m ] separatedBy: [html space]]]]! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:38'!
renderFieldWithId: anId on: html
	 html textInput
		id: anId;
		on: #value of: self! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 18:12'!
renderLabelFor: anId on: html
	html controlLabel
		for: anId;
		with: definition label! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:10'!
reset
	value := model copy.! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:10'!
save
	definition setModelValue: value ! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/4/2012 19:11'!
selector
	^definition selector! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:45'!
valid
	^messages isEmpty! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 18:02'!
validate
	[ definition assertValid: value.
		messages := #() ] on: MbValidationError do: [ :e | messages := Array with: e messageText ].
! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2012 09:31'!
value
	^value! !

!MbField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/8/2012 20:24'!
value: aValue
	value := aValue.
	self validate.
	onChange value: aValue! !

MbField subclass: #MbNumericField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbNumericField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:25'!
supports: aDefinition
	^aDefinition typeHint = #numeric! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:30'!
renderFieldOn: html
	| id |
	html label
		for: (id := html nextId);
		with: (definition label).
	definition currency ifNotNilDo: [ :c | html render: c ].
	html textInput
		id: id;
		on: #value of: self.
! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:57'!
renderFieldWithId: anId on: html
	definition currency notNil 
		ifTrue: [	html div class: 'input-prepend'; with: [
				html span class: 'add-on'; with: definition currency.
				html textInput id: anId; on: #value of: self ]]
		ifFalse: [ html textInput id: anId; on: #value of: self]
! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 18:00'!
reset
	value :=  model ifNotNilDo: [ :m | m printShowingDecimalPlaces: definition precision ]! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:32'!
save
	definition setModelValue: (definition precision 
		ifNil: [ Number readFrom: value ]
		ifNotNil: [ :p | (Number readFrom: value) asScaledDecimal: p])! !

!MbNumericField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:54'!
value
	^super value! !

MbField subclass: #MbPasswordField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbPasswordField class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:07'!
supportedRenderHints
	^#(password)! !

!MbPasswordField methodsFor: 'as yet unclassified' stamp: 'StuartHerring 4/1/2012 15:07'!
renderFieldWithId: anId on: html
	 html passwordInput
		id: anId;
		on: #value of: self! !

MbValidatedComponent subclass: #MbFieldGroup
	instanceVariableNames: 'model fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbFieldGroup class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 18:32'!
definition: aDefinition model: anObject
	^self on: anObject! !

!MbFieldGroup class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:47'!
on: anObject
	^self basicNew
		initializeWithObject: anObject;
		yourself! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:26'!
children
	^fields! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 18:49'!
initializeWithObject: anObject
	self initialize.
	model := anObject.
	fields := (model mbDefinitions reject: [ :d | d readOnly ])
		collect: [ :def | MbField definition: def model: (anObject perform: def selector) ]! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:27'!
renderContentOn: html
	self renderFieldsOn: html! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:25'!
renderFieldsOn: html
	fields
		do: [ :f | 	html render: f]! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:25'!
save
	self valid ifTrue: [
		fields do: [ :f | f save ]]! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:26'!
valid
	^fields allSatisfy: [ :f | f valid]! !

!MbFieldGroup methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/22/2012 19:14'!
value
	^model! !

MbFieldGroup subclass: #MbForm
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:16'!
cancel
	self answer: nil! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:51'!
renderContentOn: html
	html horizontalForm
		defaultAction: [ self save ];
		with: [ html fieldSet: [
				title ifNotNil: [ html legend: title ].
				self renderFieldsOn: html. 
				html formActions: [ html submitButton
					class: 'btn';
					bePrimary;
					callback: [ self save ];
					value: 'Save'.
				html space.
				html cancelButton
					class: 'btn';
					value: 'Cancel';
					callback: [ self cancel]]]]! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/21/2012 20:57'!
save
	self valid
		ifFalse: [ ^ self ].
	fields do: [ :f | f save ].
	self answer: model! !

!MbForm methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 18:49'!
title: aString
	title := aString! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:43'!
messages
	"Returns a collection of error messages for the component"
	^#()! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:07'!
save
! !

!MbValidatedComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 19:40'!
valid
	^false! !

!SequenceableCollection methodsFor: '*mabinogi-web-components' stamp: 'StuartHerring 6/21/2012 18:13'!
asTableSource
	^MbCollectionTableSource on: self! !

Object subclass: #MbTableSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

MbTableSource subclass: #MbBlockTableSource
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbBlockTableSource class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:09'!
on: aBlock
	^self basicNew 
		initializeWith: aBlock;
		yourself! !

!MbBlockTableSource methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 19:18'!
initializeWith: aBlock
	self initialize.
	block := aBlock.! !

!MbBlockTableSource methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:09'!
items
	^block value! !

MbTableSource subclass: #MbCollectionTableSource
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbCollectionTableSource class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:10'!
on: aCollection
	^self basicNew
		initializeWith: aCollection;
		yourself! !

!MbCollectionTableSource methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:11'!
initializeWith: aCollection
	self initialize.
	collection := aCollection! !

!MbCollectionTableSource methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:11'!
items
	^collection! !

!MbTableSource class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:08'!
asTableSource
	^self! !

!MbTableSource methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/21/2012 18:06'!
items
	"Should answer a collection of items"
	self subclassResponsibility! !

WAObject subclass: #MbAbstractTableColumn
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbAbstractTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:18'!
heading
	^heading! !

!MbAbstractTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/16/2012 12:07'!
heading: aString
	heading := aString! !

!MbAbstractTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:19'!
renderHeadingOn: html
	html tableHeading: self heading! !

!MbAbstractTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:19'!
renderItem: anObject on: html
	self subclassResponsibility! !

MbAbstractTableColumn subclass: #MbSimpleValueTableColumn
	instanceVariableNames: 'valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbSimpleValueTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
forDefinition: aDefinition
	^self new
		heading: aDefinition label;
		valueBlock: [ :item | (aDefinition copy setModel: item) printValue ];
		yourself.! !

!MbSimpleValueTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
forSelector: aSymbol
	^self new
		heading: aSymbol asCapitalizedPhrase;
		valueBlock: [ :item | item perform: aSymbol ];
		yourself.! !

!MbSimpleValueTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
initialize
	super initialize.
	valueBlock := [ :v | ]! !

!MbSimpleValueTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
renderItem: anObject on: html
	html tableData: [
		html render: (self valueForItem: anObject)]! !

!MbSimpleValueTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
valueBlock: aOneArgumentBlock
	valueBlock := aOneArgumentBlock.! !

!MbSimpleValueTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:16'!
valueForItem: anObject
	^valueBlock value: anObject! !

MbAbstractTableColumn subclass: #MbTableColumn
	instanceVariableNames: 'renderBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mabinogi-Web-Components'!

!MbTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 19:58'!
forDefinition: aDefinition
	^self new
		heading: aDefinition label;
		valueBlock: [ :item | (aDefinition copy setModel: item) printValue ];
		yourself.! !

!MbTableColumn class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/13/2012 20:00'!
forSelector: aSymbol
	^self new
		heading: aSymbol asCapitalizedPhrase;
		valueBlock: [ :item | item perform: aSymbol ];
		yourself.! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:23'!
initialize
	super initialize.
	renderBlock := [ :v :h| ]! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:24'!
renderBlock: aTwoArgumentBlock
	" First argument is the object, second is the Canvas"
	renderBlock := aTwoArgumentBlock! !

!MbTableColumn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 17:23'!
renderItem: anObject on: html
	html tableData: [
		renderBlock value: anObject value: html ] ! !
